//
//  GridViewTest.m
//  TestApp
//
//  Created by b0ner on 11/10/28.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "GridViewTest.h"
#define ZUKANDA_API @"http://zukanda.jp/api/zukan/list?page_count=21"
#define FB_ALBUM_PHOTOS @"https://graph.facebook.com/243888275663260/photos"

@implementation GridViewTest

@synthesize itemList;

UIView *loadView;

- (NSData *)getData:(NSString *)url; {
	NSURLRequest *request = [NSURLRequest requestWithURL:
							 [NSURL URLWithString:[url stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding]]
                                             cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval:30.0];
	NSURLResponse *response;
	NSError       *error;
	NSData *result = [NSURLConnection sendSynchronousRequest:request 
										   returningResponse:&response error:&error];
	if (result == nil) {
		NSLog(@"NSURLConnection error %@", error);
        return nil;
	}
	
	return result;
}

- (UIImage *) getImage:(NSString *)url {
//    NSData *imgData = [ImageCache getDataByKey:url];
//    if (imgData != nil) {
//        return [UIImage imageWithData:imgData];
//    }

    NSData *imgData = [[NSData alloc] initWithContentsOfURL:[NSURL URLWithString:url]];
    //NSData *imgData = [self getData:url];
    //[ImageCache setData:imgData byKey:url];
	return [UIImage imageWithData:imgData];
}

- (void)getAlbumPhoto {
    NSData *respData = [self getData:FB_ALBUM_PHOTOS];
    NSString *jsonString = [[[NSString alloc] initWithData:respData 
                                                  encoding:NSUTF8StringEncoding] autorelease];
    
    NSDictionary *jsonData = [jsonString JSONValue];
    NSArray *listArr = [jsonData objectForKey:@"data"];
    self.itemList = [[NSMutableArray alloc] init];
    for (NSDictionary *item in listArr) {
        Item *vItem = [[Item alloc] init];
        vItem.name = [item objectForKey:@"name"];
        vItem.picture = [item objectForKey:@"picture"];
        
        [itemList addObject:vItem];
    }
}

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    [super dealloc];
    [itemList release];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    self.title = @"GridView";
    
//    self.itemList = [[NSMutableArray alloc] init];
//    for (int a=0; a<12; a++) {
//        Item *item = [[Item alloc] init];
//        item.title = @"";
//        item.image = @"blank.png";
//        
//        [itemList addObject:item];
//    }
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    self.itemList = nil;
    [ImageCache clearCache];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    main_queue = dispatch_get_main_queue();
    getList_queue = dispatch_queue_create("testapp.gridview.getlist", NULL);
    
    dispatch_async(getList_queue, ^{
        [self getAlbumPhoto];
        dispatch_async(main_queue, ^{
            [self.tableView reloadData];
        });
    });
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    dispatch_release(getList_queue);
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    return 1;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
        cell.accessoryType = UITableViewCellAccessoryNone;
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
    }
    
    for (UIView *subView in cell.contentView.subviews) {
        [subView removeFromSuperview];
    }
    
    if (!itemList) {
        cell.textLabel.text = @"Loading...";
        return cell;
    } else {
        cell.textLabel.text = nil;
    }
    
    int n = [itemList count];
    int i = 0; int i1 = 0;
    int rowNum = 3;
    int gridPadding = 5;
    int gridSize = 100;
    while (i<n) {
        int yy = rowNum + i1*(gridSize + gridPadding);
        int j = 0;
        for (j=0; j<rowNum; j++) {
            if (i >= n) break;
            
            Item *item = [itemList objectAtIndex:i];
            
            CGRect rect = CGRectMake(5 + (gridSize+gridPadding)*j, yy, gridSize, gridSize);
            UIButton *button = [[UIButton alloc] initWithFrame:rect];
            [button setFrame:rect];
            
            global_queue = dispatch_get_global_queue(0, 0);
            dispatch_async(global_queue, ^{
                UIImage *btnImage = [self getImage:item.picture];
                dispatch_sync(main_queue, ^{
                    [button setImage:[btnImage grayImage] forState:UIControlStateHighlighted];
                    [button setImage:btnImage forState:UIControlStateNormal];
//                    [button.imageView setContentMode:UIViewContentModeCenter];
//                    [button.imageView setContentMode:UIViewContentModeScaleAspectFit];
                    [button.imageView setContentMode:UIViewContentModeScaleAspectFill];
//                    [button.imageView setContentMode:UIViewContentModeScaleToFill];
                });
            });
            
            NSString *tagValue = [NSString stringWithFormat:@"%d%d", indexPath.section+1, i];
            button.tag = [tagValue intValue];
            
            [cell.contentView addSubview:button];
            [button release];
            
            i++;
        }
        
        i1 = i1 + 1;
    }
    
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (!itemList) {
        return 80;
    }
    int numRows = [itemList count] / 3;
    return numRows * 105;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     [detailViewController release];
     */
}

@end
