//
//  ImageAddition.m
//  TestApp
//
//  Created by b0ner on 11/10/28.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ImageAddition.h"

@implementation UIImage (Effect)
//-(UIImage*)grayImage {
//	[self grayImage:CGRectMake(0, 0, 320, 480)];
//}

- (UIImage *)grayImage {
	// CGImageを取得する
	CGImageRef cgImage;
	cgImage = self.CGImage;
    
	// 画像情報を取得する
	size_t width;
	size_t height;
	size_t bitsPerComponent;
	size_t bitsPerPixel;
	size_t bytesPerRow;
	CGColorSpaceRef colorSpace;
	CGBitmapInfo bitmapInfo;
	bool shouldInterpolate;
	CGColorRenderingIntent intent;
	width = CGImageGetWidth(cgImage);
	height = CGImageGetHeight(cgImage);
	bitsPerComponent = CGImageGetBitsPerComponent(cgImage);
	bitsPerPixel = CGImageGetBitsPerPixel(cgImage);
	bytesPerRow = CGImageGetBytesPerRow(cgImage);
	colorSpace = CGImageGetColorSpace(cgImage);
	bitmapInfo = CGImageGetBitmapInfo(cgImage);
	shouldInterpolate = CGImageGetShouldInterpolate(cgImage);
	intent = CGImageGetRenderingIntent(cgImage);
    
	// データプロバイダを取得する
	CGDataProviderRef dataProvider = CGImageGetDataProvider(cgImage);
    
	// ビットマップデータを取得する
	CFDataRef data = CGDataProviderCopyData(dataProvider);
	UInt8* buffer = (UInt8*)CFDataGetBytePtr(data);
    
	// ビットマップに効果を与える
    
	NSUInteger i, j;
//	for (j = rect.origin.y ; j < rect.origin.y + rect.size.height; j++) {
//		for (i = rect.origin.x; i < rect.origin.x + rect.size.width; i++) {
    for (j=0; j<height; j++) {
        for (i=0; i<width; i++) {
			// ピクセルのポインタを取得する
			UInt8* tmp = buffer + j * bytesPerRow + i * 4;
            
			// RGBの値を取得する
			UInt8 r, g, b;
			r = *(tmp + 0);
			g = *(tmp + 1);
			b = *(tmp + 2);
            
			// 輝度値を計算する
//            UInt8 y = (77 * r + 28 * g + 151 * b) / 256;
//            UInt8 y = (77 * r + 28 * g + 151 * b) >> 8;
            UInt8 y = ((0.299*1024) * r + (0.587*1024) * g + (0.114*1024) + b) / 2048 ;
//            UInt8 y = (2*r + 4*g + b) / 7;
            
			// 輝度の値をRGB値として設定する
			*(tmp + 0) = y;//r
			*(tmp + 1) = y;//g
			*(tmp + 2) = y;//b
		}
    }
    
	// 効果を与えたデータを作成する
	CFDataRef effectedData;
	effectedData = CFDataCreate(NULL, buffer, CFDataGetLength(data));
    
	// 効果を与えたデータプロバイダを作成する
	CGDataProviderRef effectedDataProvider;
	effectedDataProvider = CGDataProviderCreateWithCFData(effectedData);
    
	// 画像を作成する
	CGImageRef effectedCgImage = CGImageCreate(
                                               width, height,
                                               bitsPerComponent, bitsPerPixel, bytesPerRow,
                                               colorSpace, bitmapInfo, effectedDataProvider,
                                               NULL, shouldInterpolate, intent);
    
    UIImage* effectedImage = [[[UIImage alloc] initWithCGImage:effectedCgImage] autorelease];
    
	// 作成したデータを解放する
	CGImageRelease(effectedCgImage);
	CFRelease(effectedDataProvider);
	CFRelease(effectedData);
	CFRelease(data);
    
	return effectedImage;
}

@end