//
//  MapViewTest.m
//  TestApp
//
//  Created by b0ner on 11/11/09.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "MapViewTest.h"

@implementation MapViewTest

@synthesize mapview, localLabel, localManager;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    [super dealloc];
    mapview.delegate = nil;
    localManager.delegate = nil;
    [mapview release];
    [localLabel release];
    [localManager release];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (CLLocationCoordinate2D) addressLocation {
    NSString *urlString = @"http://maps.google.com/maps/geo?q=shibuya&output=csv&key=ABQIAAAAe6ZwwuPkSdfUtGhfdemEbhT2yXp_ZAY8_ufC3CFXhHIE1NvwkxRl9lfEy6UtfPK3W3oZ4lLe6r5uqw";
    
//    urlString = @"http://maps.google.co.th/maps/geo?msid=218138482391059342984.0004af9f17970397c70cf&msa=0&ll=13.824745,100.704803&spn=0.338711,0.565109&output=csv&key=ABQIAAAAe6ZwwuPkSdfUtGhfdemEbhT2yXp_ZAY8_ufC3CFXhHIE1NvwkxRl9lfEy6UtfPK3W3oZ4lLe6r5uqw";
    
    NSString *locationString = [NSString stringWithContentsOfURL:[NSURL URLWithString:urlString]];
    NSArray *listItems = [locationString componentsSeparatedByString:@","];
    
    double latitude = 0.0;
    double longitude = 0.0;
    
    if([listItems count] >= 4 && [[listItems objectAtIndex:0] isEqualToString:@"200"]) {
        latitude = [[listItems objectAtIndex:2] doubleValue];
        longitude = [[listItems objectAtIndex:3] doubleValue];
    }
    else {
        //Show error
    }
    CLLocationCoordinate2D location;
    location.latitude = latitude;
    location.longitude = longitude;
    
    return location;
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    mapview.delegate = self;
    
//    CLLocationManager *locationManager = [[CLLocationManager alloc] init];
//    if ([CLLocationManager locationServicesEnabled]){ // 位置情報が取得可能か
//        locationManager.delegate = self;
//        [locationManager startUpdatingLocation]; // 位置取得開始
//    } else {
//        NSLog(@"ロケーションサービスを利用できません");
//    }
    
    if ([CLLocationManager locationServicesEnabled]) {
        self.localManager = [[CLLocationManager alloc] init];
        localManager.delegate = self;
        localManager.distanceFilter = kCLHeadingFilterNone;
        localManager.desiredAccuracy = kCLLocationAccuracyBest;
    }
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [localManager startUpdatingLocation];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    [localManager stopUpdatingHeading];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
    self.mapview = nil;
    self.localLabel = nil;
    self.localManager = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (void)locationManager:(CLLocationManager *)manager didUpdateToLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation
{
    //CLLocationCoordinate2D coordinate = newLocation.coordinate;
    CLLocationCoordinate2D coordinate = [self addressLocation];
    
    
    MKCoordinateRegion zoom = mapview.region;
    zoom.span.latitudeDelta = 0.001;
    zoom.span.longitudeDelta = 0.001;
    
    [mapview setRegion:zoom animated:YES];
    //[mapview setCenterCoordinate:newLocation.coordinate animated:YES];
    [mapview setCenterCoordinate:coordinate];
    [localLabel setText:[NSString stringWithFormat:
                         @"緯度:%.2f 軽度:%.2f 方位:%.0f",
                         coordinate.latitude,
                         coordinate.longitude,0]];
}

@end
