//
//  RootViewController.m
//  TestApp
//
//  Created by b0ner on 11/10/20.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "RootViewController.h"

@implementation RootViewController

@synthesize listText;

- (void)viewDidLoad
{
    self.title = @"TestApp";
    NSMutableArray *listVal = [[NSMutableArray alloc] init];
    [listVal addObject:@"UITextView test"];
    [listVal addObject:@"TableView test"];
    [listVal addObject:@"UIWebView test"];
    [listVal addObject:@"GridView test"];
    [listVal addObject:@"MKMapView test"];
    self.listText = listVal;
    [listVal release];
    
    [[UIApplication sharedApplication] setStatusBarStyle:UIStatusBarStyleBlackOpaque];
    
    [super viewDidLoad];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

/*
 // Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations.
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
 */

// Customize the number of sections in the table view.
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [listText count];
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault 
                                       reuseIdentifier:CellIdentifier] autorelease];
    }
    NSString *rowText = [listText objectAtIndex:indexPath.row];
    cell.textLabel.text = rowText;

    // Configure the cell.
    return cell;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete)
    {
        // Delete the row from the data source.
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }
    else if (editingStyle == UITableViewCellEditingStyleInsert)
    {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view.
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (indexPath.row == 0) {
        InputView *iv = [[InputView alloc] initWithNibName:@"InputView" bundle:nil];
        [self.navigationController pushViewController:iv animated:YES];
        [iv release];
    } else if (indexPath.row == 1) {
        TableViewTest *tvTest = [[TableViewTest alloc] initWithNibName:@"TableViewTest" bundle:nil];
        [self.navigationController pushViewController:tvTest animated:YES];
        [tvTest release];
    } else if (indexPath.row == 2) {
        WebViewTest *web = [[WebViewTest alloc] initWithNibName:@"WebViewTest" 
                                                         bundle:nil];
        [self.navigationController pushViewController:web animated:YES];
        [web release];
    } else if (indexPath.row == 3) {
        GridViewTest *grid = [[GridViewTest alloc] initWithNibName:@"GridViewTest" bundle:nil];
        [self.navigationController pushViewController:grid animated:YES];
        [grid release];
    } else if (indexPath.row == 4) {
        MapViewTest *map = [[MapViewTest alloc] initWithNibName:@"MapViewTest" bundle:nil];
        [self.navigationController pushViewController:map animated:YES];
        [map release];
    }
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Relinquish ownership any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload
{
    [super viewDidUnload];

    // Relinquish ownership of anything that can be recreated in viewDidLoad or on demand.
    // For example: self.myOutlet = nil;
}

- (void)dealloc
{
    [super dealloc];
}

@end
