//
//  WebViewTest.m
//  TestApp
//
//  Created by b0ner on 11/10/25.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "WebViewTest.h"


@implementation WebViewTest

NSString *urlStr;
NSURLRequest *URL_REQ;

UIActivityIndicatorView *spinner;

- (void)showAlert:(NSString *)msg
{
    UIAlertView *alertLogout = [[UIAlertView alloc]initWithTitle:@"Zukanda!"
                                                         message:msg 
                                                        delegate:self 
                                               cancelButtonTitle:@"OK" 
                                               otherButtonTitles:nil, nil];
    [alertLogout show];
    [alertLogout release];
}


- (void)webViewDidStartLoad:(UIWebView *)webView
{
    
}

- (NSString *)stringByDecodingURLFormat
{
    NSString *result = [(NSString *)self stringByReplacingOccurrencesOfString:@"+" withString:@" "];
    result = [result stringByReplacingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
    return result;
}

- (BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType
{
    NSString *url = [[[request URL] standardizedURL] absoluteString];
    NSLog(@"URL load:%@",url);
    if ([urlStr isEqual:url]) {
        NSLog(@"top");
        return YES;
    }
    
    
    NSError *err = nil;
    NSString *host = [NSString stringWithFormat:@"%@(.+)",urlStr];
    
    NSRegularExpression *regexp = [NSRegularExpression 
                                   regularExpressionWithPattern:host
                                   options:0 
                                   error:&err];
    NSTextCheckingResult *match = [regexp firstMatchInString:url 
                                                     options:0 
                                                       range:NSMakeRange(0, [url length])];
    
    NSString *fileName = [url substringWithRange:[match rangeAtIndex:1]];
    if (err != nil) {
        NSLog(@"load ERROR:%@", err);
    } else if (![fileName isEqual:@""]) {
        NSLog(@"RegExp: %@", fileName);
        [self showAlert:[fileName stringByReplacingPercentEscapesUsingEncoding:NSUTF8StringEncoding]];

        return NO;
    }
    
    
    return NO;
}

- (void)webViewDidFinishLoad:(UIWebView *)webView
{
    [spinner removeFromSuperview];
    [UIApplication sharedApplication].networkActivityIndicatorVisible = NO;
}
- (void)webView:(UIWebView *)webView 
didFailLoadWithError:(NSError *)error 
{
    [UIApplication sharedApplication].networkActivityIndicatorVisible = NO;
}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    if (webView.loading) {
        [webView stopLoading];
    }
    webView.delegate = nil;
    [webView release];
    [URL_REQ release];
    [spinner release];

    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    webView.delegate = self;
    
    urlStr = @"http://zukanda.jp/";
    NSURL *url = [NSURL URLWithString:urlStr];
    URL_REQ = [[NSURLRequest alloc] initWithURL:url];
    
    CGRect cgRect = [[UIScreen mainScreen] bounds];
    CGSize cgSize = cgRect.size;
    spinner = [[UIActivityIndicatorView alloc] 
               initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleGray];
    [spinner setCenter:CGPointMake(cgSize.width/2.0, cgSize.height/2.0)];
    [spinner setAlpha:0.8];
    [self.view addSubview:spinner];
    [spinner startAnimating];
    
    [UIApplication sharedApplication].networkActivityIndicatorVisible = YES;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    if (webView.loading) {
        [webView stopLoading];
        webView.delegate = nil;
    }
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    [webView loadRequest:URL_REQ];
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
    if (webView.loading) {
        [webView stopLoading];
    }
    [UIApplication sharedApplication].networkActivityIndicatorVisible = NO;
}

- (void)viewDidUnload
{
    [super viewDidUnload];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end
